apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ redis_name }}-proxy
  namespace: {{ namespace }}
data:
  haproxy.cfg: |
    global
        log stdout format raw local0
        maxconn 10240
        spread-checks 5
        stats socket /tmp/hactl level admin
        stats timeout 30s

    defaults
        log global
        mode tcp
        maxconn 10240
        timeout client 1s
        timeout connect 2s
        timeout queue 10s
        timeout server 5s
{% if do_exporters %}

    frontend stats
        bind *:9113
        mode http
        http-request use-service prometheus-exporter if { path /metrics }
        stats enable
        stats uri /stats
        stats refresh 10s
{% endif %}

    frontend redis
        bind *:6379
        default_backend redis-backend

    resolvers dns
        #nameserver kube-dns 169.254.25.10:53
        parse-resolv-conf
        resolve_retries 3
        timeout resolve 1s
        timeout retry 1s
        hold other 30s
        hold refused 30s
        hold nx 30s
        hold timeout 30s
        hold valid 10s
        hold obsolete 30s

    backend redis-backend
        option tcp-check
        tcp-check send PING\r\n
        tcp-check expect string +PONG
        tcp-check send info\ replication\r\n
        tcp-check expect string role:master
        tcp-check send QUIT\r\n
        tcp-check expect string +OK
        balance leastconn
{% for n in range(redis_replicas | int) %}
        server redis-{{ loop.index0 }} {{ redis_name }}-{{ loop.index0 }}.{{ redis_name }}.{{ namespace }}.svc.{{ cluster_domain }}:6379 check resolvers dns check inter 5000
{% endfor %}
